---
import Layout from "../../layouts/Layout.astro";
import { IProduct } from "../../types";

export async function getStaticPaths() {
    const response = await fetch('https://fakestoreapi.com/products')
    const products = await response.json() as IProduct[]

    return products.map(product => (
        {
           params: { id: product.id.toString() },
           props: { product },
        }
    ))
}

interface Props{
   product: IProduct 
}

const { id } = Astro.params
const { product } = Astro.props as Props
---

<Layout title={product.title}>
    <h3 class='mb-2'>{product.title}</h3>
    <img src={product.image} class='w-1/4' alt={product.title} />
    <span class='font-bold'>{product.price}</span>
    <div>
        <p>{product.description}</p>
        <p>Rate: <span style={{ fontWeight: 'bold' }}>{product?.rating?.rate}</span> </p>
    </div>
</Layout>